/*****************************************************************************
*************** VYPIS KNIHOVNICH FUNKCI HEADER SOUBORU MOUSE.H ***************
*****************************************************************************/

#include <dos.h>

/*   vyvolani interuptu mysi h33    */
#define   INT    geninterrupt(0x0033);

extern int  ax, bx, cx, dx;         /* puvodni promenne programu mys.cpp */

unsigned reset(void)
{
	_AX = 0x0000;
	INT;
	ax = _AX;             /* hodnota pro urceni aktivnosti ovladace mysi */
	bx = _BX;             /* cislo nebo bitova maska poctu tlacitek mysi */
return(ax);
}

void curzor_on(void)       /* aktivace kurzoru mysi */
{
	_AX = 0x0001;
	INT;
return;
}

void curzor_off(void)      /* deaktivace kurzoru mysi */
{
	_AX = 0x0002;
	INT;
return;
}

void stand(void)
{
	_AX = 0x0003;
	INT;
	bx = _BX;             /* bitova maska stavu tlacitek (bit 0,1,2) */
	cx = _CX;             /* x-ova souradnice polohy kurzoru mysi */
	dx = _DX;             /* y-ova souradnice polohy kurzoru mysi */
return;
}

void locate(int x, int y)
{
	_AX = 0x0004;
	_CX = x;              /* presun kurzoru na souradnice (_CX,_DX) */
	_DX = y;
	INT;
return;
}

void vertical(int x_min, int x_max)
{
	_AX = 0x0007;
	_CX = x_min;        /* minimalni hodnota x-oveho rozsahu pohybu mysi */
	_DX = x_max;        /* maximalni hodnota x-oveho rozsahu pohybu mysi */
	INT;
return;
}

void horizontal(int y_min, int y_max)
{
	_AX = 0x0008;
	_CX = y_min;        /* minimalni hodnota y-oveho rozsahu pohybu mysi */
	_DX = y_max;        /* maximalni hodnota y-oveho rozsahu pohybu mysi */
	INT;
return;
}