/*****************************************************************************
********************* PROGRAM PRO TESTOVANI FUNKCI MYSI **********************
*****************************************************************************/

#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include "mouse.h"

int ax, bx, cx, dx,               /* pomocne promenne pro uschovu registru */
    lxmin = 0, lxmax = 632,       /* 4 promenne definujici velikost okna */
    lymin = 0, lymax = 192;

int getbit(int p);            /* vraci hodnotu 'p'-teho bitu promenne 'bx' */
int input(void);              /* funkce pro nacteni trojciferne hodnoty */
void lock1(void);             /* nastaveni horniho leveho rohu okna */
void lock2(void);             /* nastaveni dolniho praveho rohu okna */
void unlock(void);            /* maximalni roztazeni okna */
void move(void);              /* presun kurzoru na zadane souradnice */


int main(void)
{
	int key;                     /* ASCII hodnota stisknute klavesy */

	clrscr();
						    /* test aktivity driveru mysi */
	if( reset() != 65535 ) {
		printf("Driver mysi neni nainstalovan !\n");
		return(0);
		}
	else
		printf("Mys je %d-tlacitkova !", bx);

	_setcursortype(_NOCURSOR);                /* vypnuti kurzoru */
	getch();
	clrscr();

	printf("Stiskni 'Q' pro ukonceni !\n\n");
	printf("'O' - uzamceni horniho leveho rohu na pozici kurzoru\n");
	printf("'P' - uzamceni dolniho praveho rohu na pozici kurzoru\n");
	printf("'U' - odemceni cele pracovni plochy\n");
	printf("'I' - presun kurzoru na urcene souradnice");

	curzor_on();                              /* aktivace kurzoru mysi */
	for(;;) {

		if( kbhit() ) {
			key = getch();
			if( isupper(key) )              /* prevod na male pismeno */
				key = tolower(key);

			if( key == 'q' )                /* ukonceni behu programu */
			break;

			switch ( key ) {
				case 'o':                  /* nastaveni velikosti okna */
					lock1();
					break;
				case 'p':
					lock2();
					break;
				case 'u':
					unlock();
					break;
				case 'i':                  /* presun kurzoru mysi  */
					move();               /* na zadane souradnice */
				}
			}
									  /* cteni pozice mysi */
		stand();                             /* a stavu tlacitek  */
		gotoxy(1,25);
		printf("X:%4d  Y:%4d", cx, dx);
		gotoxy(25,25);
		printf("Tlacitka:%24s","");
		if( getbit(0) ) {
			gotoxy(35, 25);
			printf("LEVE");
			}
		if( getbit(2) ) {
			gotoxy(41, 25);
			printf("PROSTREDNI");
			}
		if( getbit(1) ) {
			gotoxy(53, 25);
			printf("PRAVE");
			}
	}

	curzor_off();                             /* deaktivace kurzoru mysi */
	_setcursortype(_NORMALCURSOR);            /* zapnuti kurzoru */
	clrscr();

return(0);
}



int getbit(int p)
{
return((bx >> p) & 1);
}

int input(void)
{
	int i, x, key;
	x = 0;
	for(i = 100; i > 0; i /= 10) {
			do   key = getch();             /* test na stisk cislice */
			while( !isdigit(key) );
			printf("%c", key);
			x += (key - '0') * i;
			}
return(x);
}

void lock1(void)
{
	stand();
	vertical(cx, lxmax);         /* nastaveni x-oveho rozsahu pohybu mysi */
	horizontal(dx, lymax);       /* nastaveni y-oveho rozsahu pohybu mysi */
	lxmin = cx;
	lymin = dx;
return;
}

void lock2(void)
{
	stand();
	vertical(lxmin, cx);
	horizontal(lymin, dx);
	lxmax = cx;
	lymax = dx;
return;

}
void unlock(void)
{
	vertical(0, 632);         /* nastaveni maximalnho rozsahu pohybu mysi */
	horizontal(0, 192);
	lxmin = lymin = 0;
	lxmax = 632;
	lymax = 192;
return;
}

void move(void)
{
	gotoxy(1,25);
	delline();                /* vymazani posledniho radku */
	printf("X= ");
	cx = input();
	printf("  Y= ");
	dx = input();
	locate(cx, dx);          /* nastaveni kurzoru mysi na dane souradnice */
return;
}